import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner

class MainTest(unittest.TestCase):

    higherErrorMessage = "Your count is higher than expected. Is your code counting some additional sequences? (Tip: Check your upper bound and/or constraints)"
    lowerErrorMessage = "Your count is lower than expected. Is your code missing some sequences? (Tip: Check your bounds and/or constraints)."

    def test_answer_one(self): 
        hasError = False
        try:
            p0 = 0.1
            I0 = [0.0, 3.0]
            self.assertGreaterEqual(main(p0), I0[0], self.lowerErrorMessage)
            self.assertLessEqual(main(p0), I0[1], self.higherErrorMessage)
        except IndexError:
            hasError = True
            # If this error is not caught, tmc fails main = load('src.main', 'main')
            # Thus it's important to catch it here.
            print("IndexError: You are trying to access values outside an array.")
        
        self.assertFalse(hasError, "Encountered an error. Please check your code.")
    
    def test_answer_two(self):
        hasError = False
        try:
            p1 = 0.5
            I1 = [247.0, 382.0]
            self.assertGreaterEqual(main(p1), I1[0], self.lowerErrorMessage)
            self.assertLessEqual(main(p1), I1[1], self.higherErrorMessage)
        except IndexError:
            hasError = True
            print("IndexError: You are trying to access values outside an array.")
        
        self.assertFalse(hasError, "Encountered an error. Please check your code.")

    def test_answer_three(self):
        hasError = False
        try:
            p2 = 1.0
            I2 = [9996.0, 9996.0]
            self.assertGreaterEqual(main(p2), I2[0], self.lowerErrorMessage)
            self.assertLessEqual(main(p2), I2[1], self.higherErrorMessage)
        except IndexError:
            hasError = True
            print("IndexError: You are trying to access values outside an array.")
        
        self.assertFalse(hasError, "Encountered an error. Please check your code.")


test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())